/* SECU-3  - An open source, free engine control unit
   Copyright (C) 2007 Alexey A. Shabelnikov. Ukraine, Gorlovka

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

   contacts:
              http://secu-3.org
              email: shabelnikov@secu-3.org
*/

/** \file starter.h
 * Working with starter
 * (  ).
 */

#ifndef _STARTER_H_
#define _STARTER_H_

struct ecudata_t;

/** Initialization of used I/O ports (  ) */
void starter_init_ports(void);

/** Control of starter ( )
 * \param d pointer to ECU data structure
 */
void starter_control(struct ecudata_t* d);

/** Blocking/unblocking of starter (/ )
 * \param i_state 1 - block, 0 - unblock
 */
void starter_set_blocking_state(uint8_t i_state);

#endif //_STARTER_H_
